/* scaler.c generated by valac 0.42.7, the Vala compiler
 * generated from scaler.vala, do not modify */



#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <cairo.h>


#define PDFPC_TYPE_SCALER (pdfpc_scaler_get_type ())
#define PDFPC_SCALER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PDFPC_TYPE_SCALER, pdfpcScaler))
#define PDFPC_SCALER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PDFPC_TYPE_SCALER, pdfpcScalerClass))
#define PDFPC_IS_SCALER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PDFPC_TYPE_SCALER))
#define PDFPC_IS_SCALER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PDFPC_TYPE_SCALER))
#define PDFPC_SCALER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PDFPC_TYPE_SCALER, pdfpcScalerClass))

typedef struct _pdfpcScaler pdfpcScaler;
typedef struct _pdfpcScalerClass pdfpcScalerClass;
typedef struct _pdfpcScalerPrivate pdfpcScalerPrivate;
enum  {
	PDFPC_SCALER_0_PROPERTY,
	PDFPC_SCALER_NUM_PROPERTIES
};
static GParamSpec* pdfpc_scaler_properties[PDFPC_SCALER_NUM_PROPERTIES];

struct _pdfpcScaler {
	GObject parent_instance;
	pdfpcScalerPrivate * priv;
	gdouble initial_width;
	gdouble initial_height;
};

struct _pdfpcScalerClass {
	GObjectClass parent_class;
};


static gpointer pdfpc_scaler_parent_class = NULL;

GType pdfpc_scaler_get_type (void) G_GNUC_CONST;
pdfpcScaler* pdfpc_scaler_new (gdouble width,
                               gdouble height);
pdfpcScaler* pdfpc_scaler_construct (GType object_type,
                                     gdouble width,
                                     gdouble height);
void pdfpc_scaler_scale_to (pdfpcScaler* self,
                            gint width,
                            gint height,
                            gboolean centered,
                            gboolean allow_cutoff,
                            GdkRectangle* result);
static void pdfpc_scaler_finalize (GObject * obj);


/**
         * Create a new Scaler taking initial width and height as input
         */
pdfpcScaler*
pdfpc_scaler_construct (GType object_type,
                        gdouble width,
                        gdouble height)
{
	pdfpcScaler * self = NULL;
#line 46 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	self = (pdfpcScaler*) g_object_new (object_type, NULL);
#line 47 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	self->initial_width = width;
#line 48 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	self->initial_height = height;
#line 46 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	return self;
#line 78 "scaler.c"
}


pdfpcScaler*
pdfpc_scaler_new (gdouble width,
                  gdouble height)
{
#line 46 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	return pdfpc_scaler_construct (PDFPC_TYPE_SCALER, width, height);
#line 88 "scaler.c"
}


/**
         * Scale the initial dimensions to a specific measurement.
         *
         * The result is a Gdk.Rectangle, as by default the aspect_ration is
         * maintained and the result is centered in the given space.
         *
         * By default the given scaling will not cut off any information of the
         * source size. The allow_cutoff parameter allows to maximize usage of
         * the given space by allowing to cut off certain parts of the initial
         * input.
         */
void
pdfpc_scaler_scale_to (pdfpcScaler* self,
                       gint width,
                       gint height,
                       gboolean centered,
                       gboolean allow_cutoff,
                       GdkRectangle* result)
{
	GdkRectangle target = {0};
	gdouble factor = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
#line 62 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	g_return_if_fail (self != NULL);
#line 63 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	memset (&target, 0, sizeof (GdkRectangle));
#line 64 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	factor = (gdouble) 1.0f;
#line 65 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	if (width == 0) {
#line 125 "scaler.c"
		gdouble _tmp0_;
#line 66 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
		_tmp0_ = self->initial_height;
#line 66 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
		factor = height / _tmp0_;
#line 131 "scaler.c"
	} else {
#line 67 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
		if (height == 0) {
#line 135 "scaler.c"
			gdouble _tmp1_;
#line 68 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
			_tmp1_ = self->initial_width;
#line 68 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
			factor = width / _tmp1_;
#line 141 "scaler.c"
		} else {
#line 69 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
			if (allow_cutoff == TRUE) {
#line 145 "scaler.c"
				gdouble _tmp2_;
				gdouble _tmp3_;
#line 70 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
				_tmp2_ = self->initial_width;
#line 70 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
				_tmp3_ = self->initial_height;
#line 70 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
				factor = fmax (width / _tmp2_, height / _tmp3_);
#line 154 "scaler.c"
			} else {
				gdouble _tmp4_;
				gdouble _tmp5_;
#line 76 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
				_tmp4_ = self->initial_width;
#line 76 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
				_tmp5_ = self->initial_height;
#line 76 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
				factor = fmin (width / _tmp4_, height / _tmp5_);
#line 164 "scaler.c"
			}
		}
	}
#line 82 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	_tmp6_ = self->initial_width;
#line 82 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	_tmp7_ = factor;
#line 82 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	target.width = (gint) floor (_tmp6_ * _tmp7_);
#line 83 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	_tmp8_ = self->initial_height;
#line 83 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	_tmp9_ = factor;
#line 83 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	target.height = (gint) floor (_tmp8_ * _tmp9_);
#line 85 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	if (centered == TRUE) {
#line 182 "scaler.c"
		GdkRectangle _tmp10_;
		gint _tmp11_;
		GdkRectangle _tmp12_;
		gint _tmp13_;
#line 86 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
		_tmp10_ = target;
#line 86 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
		_tmp11_ = _tmp10_.width;
#line 86 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
		target.x = (gint) floor ((gdouble) ((width - _tmp11_) / 2.0f));
#line 87 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
		_tmp12_ = target;
#line 87 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
		_tmp13_ = _tmp12_.height;
#line 87 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
		target.y = (gint) floor ((gdouble) ((height - _tmp13_) / 2.0f));
#line 199 "scaler.c"
	}
#line 90 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	*result = target;
#line 90 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	return;
#line 205 "scaler.c"
}


static void
pdfpc_scaler_class_init (pdfpcScalerClass * klass)
{
#line 32 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	pdfpc_scaler_parent_class = g_type_class_peek_parent (klass);
#line 32 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	G_OBJECT_CLASS (klass)->finalize = pdfpc_scaler_finalize;
#line 216 "scaler.c"
}


static void
pdfpc_scaler_instance_init (pdfpcScaler * self)
{
}


static void
pdfpc_scaler_finalize (GObject * obj)
{
	pdfpcScaler * self;
#line 32 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PDFPC_TYPE_SCALER, pdfpcScaler);
#line 32 "/builddir/build/BUILD/pdfpc-4.3.4/src/classes/scaler.vala"
	G_OBJECT_CLASS (pdfpc_scaler_parent_class)->finalize (obj);
#line 234 "scaler.c"
}


/**
     * Scaling calculator which is able to calculate different scaling
     * scenarios while maintaining the correct aspect ratio.
     */
GType
pdfpc_scaler_get_type (void)
{
	static volatile gsize pdfpc_scaler_type_id__volatile = 0;
	if (g_once_init_enter (&pdfpc_scaler_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (pdfpcScalerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pdfpc_scaler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (pdfpcScaler), 0, (GInstanceInitFunc) pdfpc_scaler_instance_init, NULL };
		GType pdfpc_scaler_type_id;
		pdfpc_scaler_type_id = g_type_register_static (G_TYPE_OBJECT, "pdfpcScaler", &g_define_type_info, 0);
		g_once_init_leave (&pdfpc_scaler_type_id__volatile, pdfpc_scaler_type_id);
	}
	return pdfpc_scaler_type_id__volatile;
}



